/*
 * d_rmdat.c
 *
 * $Source: /source/MASTER/garden/datlib/RCS/d_rmdat.c,v $
 * $Date: 22/.1/.2 .0:.4:.1 $
 * $Author: holtzman $
 * $Locker:  $
 *
 * This file is part of the dat library.
 *
 * int d_rmdat(name)
 *
 * $Log:	d_rmdat.c,v $
 * Revision 1.9  22/.1/.2  .0:.4:.1  holtzman
 * removed some #includes
 * 
 * Revision 1.8  92/06/23  18:39:19  holtzman
 * Changed a NULL to a 0 to eradicate a type checking warning.
 * 
 * Revision 1.7  91/11/02  23:31:26  klee
 * updated for const declarations
 * 
 * Revision 1.6  90/12/08  03:53:17  kaboom
 * Replaced under RCS, moved copyright message to copyright.h.
 * 
 * Revision 1.5  89/01/13  02:44:00  jwang
 * Add M.I.T. copyright message.
 * 
 * Revision 1.4  86/08/19  11:28:29  jwang
 * Replace fork by vfork if running on a vax.
 * 
 * Revision 1.3  85/07/26  18:22:23  steve
 * change #ifdef SYMLINK to #ifndef NOSYMLINK
 * 
 *
 * remove datfile called "name" (also removes normal files)
 *	
 * Aug 13, 1984  Modified to recognize symbolic links (John Wang)
 * Aug 29, 1984  Changed include file from "dat.h" to <dat.h> (Isnardi)	
 * Sep 5,  1984  Added conditional compilation for symbolic links(John)
 */

static char rcsid[] = "$Header: /source/MASTER/garden/datlib/RCS/d_rmdat.c,v 1.9 22/.1/.2 .0:.4:.1 holtzman Exp $" ;

#include "dat.h"
#include <sys/types.h>
#include <sys/stat.h>
/* #include <stdio.h> */
/* #include <sys/param.h> */

#ifdef __sgi
#define vfork fork
#endif /* __sgi - dpwe 1994dec06 */

#define	DESCRIPTOR	"/descriptor"
#define	DATA			"/data"

int d_rmdat(name)
const char* name;
{
	struct stat statbuf;
	char buff[240];
	char *p,*p2;
	int i;
	
#ifndef NOSYMLINK		/* if symbolic links exists on target machine */
	if(lstat(name,&statbuf) == -1)
	{
		perror(name);
		return(-1);
	}
	if ((statbuf.st_mode & S_IFMT) == S_IFLNK)
	{
		fprintf(stderr,"d_rmdat: removing symbolic link %s\n",name);
		if(vfork()) wait(0);
		else execl("/bin/rm","rm",name,0);
	}
	else if ((statbuf.st_mode & S_IFMT) != S_IFDIR)	/* if not a directory */
	{
		fprintf(stderr,"d_rmdat: removing normal file %s\n",name);
		if(vfork()) wait(0);
		else execl("/bin/rm","rm",name,0);
	}
#else							/* if they don't */
	if(stat(name,&statbuf) == -1)
	{
		perror(name);
		return(-1);
	}
	if ((statbuf.st_mode & S_IFMT) != S_IFDIR)	/* if not a directory */
	{
		fprintf(stderr,"d_rmdat: removing normal file %s\n",name);
		if(vfork()) wait(0);
		else execl("/bin/rm","rm",name,0);
	}
#endif
	else
	{
		strcpy(buff,name);
		strcat(buff,DESCRIPTOR);
		if(access(buff,0) != 0)
		{
			fprintf(stderr,"d_rmdat: %s not a dat file\n",name);
			return(-1);
		}
		fprintf(stderr,"d_rmdat: removing dat file %s\n",name);
		if(vfork()) wait(0);
		else execl("/bin/rm","rm","-r",name,NULL);
	}
	return(0);
}
