/*
Copyright 1989 by the Movies of the Future Group
of the MIT Media Laboratory
All rights reserved.

Permission to use, copy, and modify this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of M.I.T. not be used in
advertising or publicity pertaining to distribution of the software
without specific, written prior permission.  This software or any
other copies thereof may not be provided or otherwise made available to
others.  No title to or ownership of the software is hereby transferred.
M.I.T. makes no representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.
*/

#include "dat.h"
#include <string.h>
#include <ctype.h>


/*
** FUNCTION: d_getkey_elem
**
** SIDE EFFECTS: Opens dat subfiles.
**
** COMMENTS: None.
*/

const char *
d_getkey_elem(datfile, keyword, index)
const DATFILE 	*datfile;  
const char	*keyword;
long	 	index;
{
    const char	*key;
    const char 	*key_ptr;
    int		 i;

    if(!(key = d_getkey(datfile, keyword)))
    {
	return(NULL);;
    }

    key_ptr = key;
    for(i = 0; i < index; ++i)
    {
	while(*key_ptr && !isspace(*key_ptr))
	{
	    ++key_ptr;
	}

	while(isspace(*key_ptr))
	{
	    key_ptr++;
	}
    }

    return(key_ptr);
}


DATFILE *
d_open_subfile(datfile, subname, mode)
DATFILE 	*datfile;  
const char	*subname;
const char 	*mode;
{
    char	*dname;
    char	 newname[1024];

    dname = d_getname(datfile);

    (void) strcpy(newname, dname);
    (void) strcat(newname, "/");
    (void) strcat(newname, subname);

    return(d_open(newname, mode));
}


int
d_close_subfile(DATFILE *datfile)
{
    return(d_close(datfile));
}


int
d_appkey_strvec(datfile, key, vecsize, strvec)
DATFILE		*datfile;
const char 	*key;
int	 	vecsize;
const char	*const strvec[];
{
    register	int	i;

    for(i = 0; i < vecsize; ++i)
    {
	if(d_appkey(datfile, key, strvec[i]) == -1)
	{
	    return(-1);
	}
	
	if(d_appkey(datfile, key, " ") == -1)
	{
	    return(-1);
	}
    }

    return(0);
}
