//
// tkDpweMisc.cc
// 
// random tk extension
// 
// dpwe@media.mit.edu 1994dec06
//

#include <assert.h>
#include <stdlib.h>

extern "C" {
#include <X11/Xlib.h>
#include "tcl.h"
#include "tk.h"
int MiscTk_Init(Tcl_Interp *interp);
   /* add the tk commands defined in this package to the interpreter */
}

static Tk_Window tkmainwin;

int xorrectCommand(ClientData clientData, Tcl_Interp *interp, 
		   int argc, char **argv)
{	/* tk command highlights a region by drawing xor for meta-widg drag */
    char rslt[32];
    int x, y, wx, wy;
    unsigned int w, h, wh, ww, bw, depth;
    Tk_Window twin;
    Display *disp;
    Window  xwin;
    Window  root;
static    Window  newwin = 0;
static    int     lx, ly;
static    unsigned int lw, lh;
static    GC      mygc;
    XRectangle pr[1];

    if(argc != 2 && argc != 6) {
	Tcl_AppendResult(interp, "wrong # args; should be \"", 
			 argv[0], " window [x y w h]\"", NULL);
	return TCL_ERROR;
    }
    twin = Tk_NameToWindow(interp, argv[1], tkmainwin);
    if(twin == NULL)  {
	sprintf(interp->result, "could not find window %s", argv[1]);
	return TCL_ERROR;
    }
    disp = Tk_Display(twin);
    xwin = Tk_WindowId(twin);
    if(argc == 2)  {
	// remove existing overlay
	if(newwin!=0)  {
	    Tk_FreeGC(disp, mygc);
	    XDestroyWindow(disp, newwin);
	    newwin = 0;
	}
	return TCL_OK;
    }
    // else argc == 6
    // get args
    x = atoi(argv[2]);
    y = atoi(argv[3]);
    w = atoi(argv[4]);
    h = atoi(argv[5]);

    if(newwin==0) {	// this is the first call - create win & GC
	XSetWindowAttributes xwa;
	XGCValues gcv;

	gcv.function = GXxor;
	gcv.foreground = (long unsigned)(-1);

//	gcv.function = GXcopy;
//	gcv.function = BlackPixel(disp, Tk_ScreenNumber(twin));

	mygc = Tk_GetGC(twin, GCFunction|GCForeground, &gcv);

	XGetGeometry(disp, xwin, &root, &wx, &wy, &ww, &wh, &bw, &depth);

	xwa.background_pixmap = None;	// transparent window
	newwin = XCreateWindow(disp, xwin, wx, wy, ww, wh, 0, 0, 
			       InputOutput, CopyFromParent, CWBackPixmap, 
			       &xwa);
	XMapWindow(disp, newwin);
//	fprintf(stderr, "newwin x %d, y %d, w %d, h %d\n", 
//		wx, wy, ww, wh);
    } else {
	// there has been a previous call - undraw the last rect
	XFillRectangle(disp, newwin, mygc, lx, ly, lw, lh);
    }
    XRaiseWindow(disp, newwin);
    XFillRectangle(disp, newwin, mygc, x, y, w, h);

    // remember what we draw to undraw next time
    lx = x; ly = y; lw = w; lh = h;

    XFlush(disp);

//  fprintf(stderr, "xor nw %d x %d, y %d, w %d, h %d\n", newwin, x, y, w, h);

    return TCL_OK;
}


int MiscTk_Init(Tcl_Interp *interp)
{   /* add the tcl commands defined in this package to the interpreter */
    Tk_Window main = Tk_MainWindow(interp);

    tkmainwin = main;

    Tcl_CreateCommand(interp, "xorrect", xorrectCommand, (ClientData) main,
		      (void (*)(ClientData)) NULL);
    return TCL_OK;
}
